<?php
/**
 * @package Sj Categories Slider for JoomShopping
 * @version 1.0.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2013 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 *
 */
defined('_JEXEC') or die;

include_once dirname(__FILE__).'/helper_base.php';

class LbCategoriesSliderHelper extends LbCategoriesSliderHelperBaseHelper{
	public static function getList(&$params){
		ini_set('xdebug.var_display_max_depth', '5');  
		$list = array();
		$list = self::getCategories($params);
		$option = "com_listbingo";
		if(!empty($list)){
			foreach($list as $item){
				$item->_description  = self::_cleanText($item->description);
				self::getLBCImages($item, $params,'imgcfgcat');
				$item->link =  GFactory::get('site::com.listbingo.helper.route')->route('index.php?option='.$option.'&view=ads&categoryid='. $item->slug);
			}
		}
        return $list;
	}
	
	private static function getCategories($params){	
		$model = GFactory::get('site::com.listbingo.model.categories');
        $country = GFactory::get('site::com.listbingo.helper.locale')->getCurrentCountry();
        $region = (int )GFactory::get('site::com.listbingo.helper.locale')->getCurrentRegion();
		$db = $model->getTable()->getDatabase();	
		$user	= GFactory::get('lib.joomla.user');
		$groups	= implode(',', $user->getAuthorisedViewLevels());
	
		$pubcond = '';
		$condition = array ();				
		$condition [] = 'c.enabled = 1';		
		$condition [] = " c.access IN ($groups)";
		$catids = $params->get('catids');
		settype($catids,'array');
		if(empty($catids )) return;
		$catid = implode(", ", $catids);
		if (count ( $condition ) > 0) {
			$pubcond = ' where ' . implode ( ' AND ', $condition ) . ' AND c.listbingo_category_id IN ('.$catid.')' ;
		}
	
		
		if (isset ( $country ) && !empty($country)) {
			$country = 'AND listbingo_country_code="' . $country.'"';
			
		}
		if (isset (  $region ) && $region > 0) {
			//$region = 'AND listbingo_region_id=' . $this->_state->regionid;	
			$suregions = GFactory::get('site::com.listbingo.model.regions')->getSubRegion ( $region );
			$suregions = array_merge(array($region) ,$suregions);
			if(count($suregions) > 0){
				
				$region = 'AND listbingo_region_id IN ('.implode(',',$suregions).')';
			}
			
		}
		
		//$expired = ' AND (expiry_date > NOW() || expiry_date="0000-00-00 00:00:00")';	
		$country = '';
		$expired = '';	
		$region = '';
		$orderby = '';
		$sort = $params->get('sort','c.listbingo_category_id');
		$ordering = $params->get('ordering','asc');
		$orderby = ' ORDER BY '.$sort.' '. $ordering ;
		$limit = '';
		if($params->get('count_cat')>0){
			$limit = 'LIMIT 0, '.$params->get('count_cat',20).' ';
		}
		$query = 'SELECT c.listbingo_category_id as id ,c.*,c.title as name,CASE WHEN CHAR_LENGTH(c.slug) THEN CONCAT_WS(\':\', c.listbingo_category_id, c.slug) ELSE c.listbingo_category_id END as slug,
		(SELECT count(listbingo_ad_id) FROM #__listbingo_ads WHERE listbingo_category_id=c.listbingo_category_id AND status=1 '.$expired.' '.$country.' '.$region.' ) as pcount,
		(SELECT ifnull(listbingo_category_id,0) from #__listbingo_categories where listbingo_category_id=c.parent_id and enabled = 1 ) as parentexists
		FROM #__listbingo_categories as c '.$pubcond .' '. $orderby .' '.$limit;	
		//echo str_replace('#_','jos', $query);
		$categories = $db->select ($query,GDatabase::FETCH_OBJECT_LIST, 'listbingo_category_id' );	
	return $categories;
		
	}

}
